#!/usr/local/bin/guile \
-e main -s
!#

;;; Problem 2: Even Fibonacci numbers

;; Each new term in the Fibonacci sequence is generated by adding the
;; previous two terms. By starting with 1 and 2, the first 10 terms
;; will be:

;; 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...

;; By considering the terms in the Fibonacci sequence whose values do
;; not exceed four million, find the sum of the even-valued terms.

;;; Code:

(use-modules (srfi srfi-1))

(define (fib< n fib)
  "Return fibinaci sequence for values less than n"
  (let ((next (+ (car fib) (cadr fib))))
    (if (> next n) fib
        (fib< n (cons next fib)))))

(define (main args)
  (let* ((fib (fib< 4000000 '(1 1)))
         (sum (fold + 0 (filter even? fib))))
    (display sum)
    (newline)))

;; End:
